/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-08 01:16
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

// from reference
struct pt { lf x, y; int id, k; };
auto cm = [](pt a, pt b){ return a.y < b.y; };
lf dist(const pt &a, const pt &b){
  return hypot(a.x - b.x, a.y - b.y);
}
pt A, B;
lf closest(vector<pt> P){
  R::sort(P, {}, &pt::x);
  set<pt, decltype(cm)> s(cm);
  lf mn = INFINITY;
  auto ptr = begin(P);
  for(pt p : P){
    while(ptr != end(P) && p.x - ptr->x >= mn)
      s.erase(*ptr++);
    auto it1 = s.lower_bound({0, p.y - mn});
    auto it2 = s.upper_bound({0, p.y + mn});
    for(pt k : R::subrange(it1, it2))
      if(lf d = dist(p, k); d < mn)
        mn = d, A = p, B = k;
    s.insert(p);
  }
  return mn;
}
// ===

ifstream fin("input.txt");
ofstream fout("output.txt");


ll N;

void solve(){
    // Code goes here ...
    fin >> N;
    vector<int> xs(N), ys(N);
    R(i, N) fin >> xs[i] >> ys[i];  
    
    vector<pt> points(N);
    R(i, N){
        int k = 1 + (xs[i] < 0 ? 1 : 0) + (ys[i] < 0 ? 2 : 0);
        points[i] = {abs(xs[i]), abs(ys[i]), i, k};
    }

    closest(points);

    int ia = A.id, ka = A.k;
    int ib = B.id, kb = B.k;

    cerr << "Closest points are: " << A.x << " and " << B.x << endl;
    cerr << " with conversion numbers " << ka << " and " << 5 - kb << endl;

    fout << ia + 1 << " " << ka << " " << ib + 1 << " " << 5 - kb << endl;
}


// =============== Main section ===============
int main(){
    solve();
    return 0;
}
        
